'''
Scenario manager and script data.
'''

# format data rule
# - the first and the last character must be LF.
# - put '@\n' at the end of a block.
SCENARIO_DATA = """
Two Worlds - A Game About The Game Called Two Worlds

Preface

Be prepared before you click. Every word in this game threatens your life.@
It's an effort to being a game, crawling out from bullets of criticism toward visual novels with zero interactivity.@
You can die a lot, as I generously gave you a plenty of lives. You might have already died once or twice, and noticed the text colored reddish. That shows how clumsy you are.@

 ....................................
  Welcome to the world of Two Worlds
 ....................................@
Character Information
Avatar
Human. Average for anything, in the same meaning as good for nothing. She was born in a family of commoners in a suburban city.@
She grew up to be a Youtuber. She earns pennies from it so far dreaming to be a member of big name.


Traits: Weak heart, nail biting @
"Hello subscribers!, I'm Avatar," a girl said in a happy tone waving her hands before her vivid color shirts. She smiled to continue her usual greeting words.@


She rouse her voice to bring back her first tension. "Today I'm gonna play a new game called Two Worlds."
She paused for a second to begin a long story.@
"It's not the one from the Germany developer, the one you often see in a Steam sales. Actually I wanted it when I saw it in the last Steam large sales. I like open world games, and I like fantasy role playing games."@
"By the way, I'm still fascinated to go back to Skyrim, but you don't like to see the same LP twice?" Her mouth shaped a mischievous smile. She straightened up herself to go back to the right track.@
"When I saw the screen shots of Two Worlds, I was like," She acted gazing upward. "Oh I got to get this, but after I saw mixed reviews of Metacritic, I wanted to save my bucks." She put her hands on her chest to cool down.@
"Then I found another Two Worlds when I checked the information. It's a freeware, and reviewers said it a very strange game. I decided to give it a go." She moved her arms feverishly. Her pink head gear shook.
"Oh, I'm excited."@


She looked into her PC monitor, overly leaning forward. "Preface, be prepared before you click." She contracted her brow.@
"Wait, wait. It's hard to read. Can I use full screen?" Chattering of key typing echoed. "Oh, yes. Here it is." The small success pleased her.@
She recited the rest of the text complaining about the uneven shape of the font. When she saw the text shoot off, she widened her eyes and mouth to the limit. Her brain knew the best time for the best reaction.@
"Oh what happened? I guess I'm hit."
She involuntarily clicked the mouse. She screamed for impatience.
"Why S is always capitalized!!!!!"@
Another scream came. "Yes, I'm clumsy, C-L-U-M-S-Y." She sang up the last part hilariously. To make the next word ironical, she showed a blunt emotion. "... It's nice you are generous."@
"Character Information, Avatar". She shook her head questionably. "I don't know how this software took my name." It seemed it's not a significant problem to her.@
"Alright,
this is my profile.
Er,
so it's a story about Youtuber, right?
Youtuber reads a story about a Youtuber."@
"What is this traits thing?" She giggled.



"Nail biting. ...Ah, I know how bad it is," She said sympathetically, nodding.@


She continued to read.
She spoke faster. "As I guessed, it's a story about a Youtuber," She said in a thoughtful way.@
"The change of the text color scared me. Is this a sort of horror story?? Will this contain a jump scare??" She threw a nervous look inadvertently rocking her body for unease feeling.@
"Oh, she wore a costume like me." She was picking both sides of her shirts to show it well while swinging her shoulders rhythmically.


She added "...I wanna get to know her..."@



"Oh shit, game over." She made an artificial disapproving face. A long drawn out "No" came from her pouted mouth as booing. Silent followed after a deep sigh.@
"OK, this is it.
I want to know what happens to her,but it's my best. Hope you enjoyed it."

Some tiredness appeared on her face, but soon it was wiped off by her bright smile.@
It got more brighter when she encouraged viewers to subscribe her channel.
At the very end of the conversation, suddenly she remembered something.
"Oh, so,"
"????what was the Two Worlds????"@

Postscript

The one side of the world ended. Why don't we close the other? I don't know how you have survived, but you are about to die.@
. . . . . . . . . . . . . . . . . . . . .                                ......                                ......     Here is your prize.        ......                                ......                                ......                                . . . . . . . . . . . . . . . . . . . . .@


You are victorious.
Fin.@
 
"""

#SCENARIO_DATA = """
#Just a sample for debugging.@Next Phase. Can you escape from it?@Third Phase.@The end.
#"""

class ScenarioManager():
    def __init__(self):
        self.margin = (8, 8)
        self.char_max = 38
        self.line_max = 8

        self.font_width = 16-8
        self.font_height = 24+4
        
        self.pointer = 0
        self.char_cnt = 1
        self.line_cnt = 1

        # remove the first and last LF from the scenario data
        self.scenario = SCENARIO_DATA[1:-1]

    def read(self):
        ret = self.scenario[self.pointer]
        if ret == '\n':
            self.char_cnt = self.char_max # force to go next line
            return "LF"
        elif ret == ' ':
            return "space"
        elif ret == "@":
            self.char_cnt = 1
            self.line_cnt = 1
            self.pointer += 1 # skip the next '\n'
            return "end of block"  # end of the block
        return ret
    
    def seek(self):
        self.pointer += 1
        if self.pointer == len(self.scenario):
            return "end of scenario"  # end of the scenario

        self.char_cnt += 1
        if self.char_cnt > self.char_max:
            self.char_cnt = 1
            self.line_cnt += 1
            if self.line_cnt > self.line_max:
                print ("scenario structure error.")
                # error handling should be added

    def seek_next_head(self):
        self.char_cnt = 1
        self.line_cnt = 1

    def get_position(self):
        ret = ((self.char_cnt-1) * self.font_width + self.margin[0], (self.line_cnt-1) * self.font_height + self.margin[1])
        return ret

    def set_game_over(self):
        self.scenario = '\n\n\n\n     ... Game Over.'
        self.pointer = 0
        self.char_cnt = 1
        self.line_cnt = 1
